VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CHook"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'

'****************************************************
'* CHook.cls                                        *
'* encapsulation of the subclassing module          *
'* Programmed: Konrad Rudolph (Mad Rat Pro.)        *
'* Last Change: 30.04.2003 21:09                    *
'* Version: 1.0.0                                   *
'****************************************************

Option Explicit

' enumeration of window messages
Public Enum WM_CONST
    WM_ACTIVATEAPP = &H1C
    WM_CAPTURECHANGED = &H215
    WM_CHANGECBCHAIN = &H30D
    WM_CHAR = &H102
    WM_CLOSE = &H10
    WM_COMMAND = &H111
    WM_COMPACTING = &H41
    WM_CONTEXTMENU = &H7B
    WM_COPYDATA = &H4A
    WM_CTLCOLORSCROLLBAR = &H137
    WM_DESTROY = &H2
    WM_DEVMODECHANGE = &H1B
    WM_DEVICECHANGE = &H219
    WM_DISPLAYCHANGE = &H7E
    WM_DRAWCLIPBOARD = &H308
    WM_DROPFILES = &H233
    WM_ENDSESSION = &H16
    WM_ENTERMENULOOP = &H211
    WM_ENTERSIZEMOVE = &H231
    WM_ERASEBKGND = &H14
    WM_EXITMENULOOP = &H212
    WM_EXITSIZEMOVE = &H232
    WM_FONTCHANGE = &H1D
    WM_GETMINMAXINFO = &H24
    WM_HOTKEY = &H312
    WM_HSCROLL = &H114
    WM_KEYDOWN = &H100
    WM_KEYUP = &H101
    WM_KILLFOCUS = &H8
    WM_LBUTTONDBLCLK = &H203
    WM_LBUTTONDOWN = &H201
    WM_LBUTTONUP = &H202
    WM_MBUTTONDBLCLK = &H209
    WM_MBUTTONDOWN = &H207
    WM_MBUTTONUP = &H208
    WM_MENUCHAR = &H120
    WM_MENUSELECT = &H11F
    WM_MOUSEACTIVATE = &H21
    WM_MOUSELEAVE = &H2A3
    WM_MOUSEMOVE = &H200
    WM_MOUSEWHEEL = &H20A
    WM_MOVE = &H3
    WM_MOVING = &H216
    WM_NCACTIVATE = &H86
    WM_NCHITTEST = &H84
    WM_NCLBUTTONDBLCLK = &HA3
    WM_NCLBUTTONDOWN = &HA1
    WM_NCLBUTTONUP = &HA2
    WM_NCMBUTTONDBLCLK = &HA9
    WM_NCMBUTTONDOWN = &HA7
    WM_NCMBUTTONUP = &HA8
    WM_NCMOUSEMOVE = &HA0
    WM_NCPAINT = &H85
    WM_NCRBUTTONDBLCLK = &HA6
    WM_NCRBUTTONDOWN = &HA4
    WM_NCRBUTTONUP = &HA5
    WM_NOTIFY = &H4E
    WM_OTHERWINDOWCREATED = &H42
    WM_OTHERWINDOWDESTROYED = &H43
    WM_PAINT = &HF
    WM_PALETTECHANGED = &H311
    WM_PALETTEISCHANGING = &H310
    WM_POWER = &H48
    WM_POWERBROADCAST = &H218
    WM_QUERYENDSESSION = &H11
    WM_QUERYNEWPALETTE = &H30F
    WM_QUERYOPEN = &H13
    WM_RBUTTONDBLCLK = &H206
    WM_RBUTTONDOWN = &H204
    WM_RBUTTONUP = &H205
    WM_SETCURSOR = &H20
    WM_SETFOCUS = &H7
    WM_SETTINGCHANGE = &H1A
    WM_SIZE = &H5
    WM_SIZING = &H214
    WM_SPOOLERSTATUS = &H2A
    WM_SYSCOLORCHANGE = &H15
    WM_SYSCOMMAND = &H112
    WM_SYSKEYDOWN = &H104
    WM_SYSKEYUP = &H105
    WM_TIMECHANGE = &H1E
    WM_USERCHANGED = &H54
    WM_VSCROLL = &H115
    WM_WININICHANGE = &H1A
End Enum

' no effect... just to make "beauty"
Public Enum hWnd
    [_]
End Enum
'----------------------------------------------------

' the events
Public Event Before( _
  ByRef uMsg As WM_CONST, _
  ByRef wParam As Long, _
  ByRef lParam As Long _
)

Public Event After( _
  ByRef uMsg As WM_CONST, _
  ByRef wParam As Long, _
  ByRef lParam As Long _
)
'----------------------------------------------------

Private m_Hook  As HookType
Private m_bInit As Boolean
'----------------------------------------------------

'----------------------------------------------------
' CreateHook
' creates a hook and assigns it to a window (or control...)
' - IN hWnd As hWnd: a handle to the window to subclass
' - IN uMsg As WM_CONST: the message to hook
'----------------------------------------------------
Public Sub CreateHook(hWnd As hWnd, uMsg As WM_CONST)
    ' tell the message to create a hook with a message
    m_Hook = DoHook(ObjPtr(Me), hWnd, uMsg)
    m_bInit = True
End Sub

'----------------------------------------------------
' DestroyHook
' destroys the hook
'----------------------------------------------------
Public Sub DestroyHook()
    If m_bInit Then
        ' tell the module to unhook all messages
        Call UnHook(m_Hook.Handle)
        m_bInit = False
    End If
End Sub

'----------------------------------------------------
' AddMsg
' adds a new message to hook
' - IN uMsg As WM_CONST: message to hook
'----------------------------------------------------
Public Sub AddMsg(uMsg As WM_CONST)
    Dim I As Long, _
        J As Long
    
    With m_Hook
        For I = 0 To UBound(.Messages)
            ' message is already hooked
            If .Messages(I) = uMsg Then _
                Exit For
            
            ' free slot spotted
            If .Messages(I) = 0 Then _
                J = I + 1
        Next I
        
        If I > UBound(.Messages) Then
            ' that means we have not found the message
            If J Then
                ' previous slot is free, use it
                .Messages(J - 1) = uMsg
            Else
                ' no slot free, enlarge array
                ReDim Preserve .Messages(I) As Long
                .Messages(I) = uMsg
            End If
        End If
    End With
    
    ' after having assigned the message, syncronize the hooking structure
    ' between the current class and the module!
    Call SyncHook(m_Hook)
End Sub

'----------------------------------------------------
' RemoveMsg
' removes a message that is hooked
' - IN uMsg AS WM_CONST: message to remove
'----------------------------------------------------
Public Sub RemoveMsg(uMsg As WM_CONST)
    Dim I As Long
    
    With m_Hook
        For I = 0 To UBound(.Messages)
            ' found message, set it to zero
            If .Messages(I) = uMsg Then _
                .Messages(I) = 0
        Next
    End With
    
    ' ... and syncronize the hooking structure!
    Call SyncHook(m_Hook)
End Sub
'----------------------------------------------------

'----------------------------------------------------
' RaiseBefore
' used by the subclassing module to notify the class of events
'----------------------------------------------------
Friend Sub RaiseBefore(uMsg As Long, wParam As Long, lParam As Long)
    RaiseEvent Before(uMsg, wParam, lParam)
End Sub

'----------------------------------------------------
' RaiseAfter
' used by the subclassing module to notify the class of events
'----------------------------------------------------
Friend Sub RaiseAfter(uMsg As Long, wParam As Long, lParam As Long)
    RaiseEvent After(uMsg, wParam, lParam)
End Sub
'----------------------------------------------------

Private Sub Class_Terminate()
    ' delete all hooks
    If m_bInit Then _
        Call DestroyHook
End Sub
